* * * * * * * * * * * * * * * * * * *
*       DISPLAY ANSI
* SHOWANSI()
* Written by: Ken LaCapria
* Date: 09/12/91
* It will read and display a charcter string that has embedded ANSI codes
* It will interpert and display the ANSI code.
*
* This function has been released to the Public Domain on 11/10/91.
* All that I ask is that I get credit for writing the function and that
* should you make any changes to it, that you send me a copy of the
* function with the changes to me so that I can learn more about programming
* techinques.
*
* This function was written as part of a program for sysops running TBBS
* bulletin board software. If you think this is a good and productive
* program, it would be appreciated if you would donate some amount of money
* to a local AIDS clinic in your area.
*
* SHOWANSI returns a null string
*   Syntax:   SHOWANSI(memvar)
*
function showansi (ansitext)
        local textlen,onechar,charpos,tempstrng,sf,sb,ef,eb,uf,ub,temprow
        local tempcol,colnpos,tempchar,tempsubstr,x,savrow,savcol,cstrng
        onechar=''
        charpos=1
        tempstrng=''
        textlen=len(ansitext)
        sf='W'
        sb='N'
        ef='W'
        eb='N'
        uf='W'
        ub='N'
        temprow=0
        tempcol=0
        colnpos=0
        savrow=0
        savcol=0

        do while charpos<=textlen
                onechar=substr(ansitext,charpos,1)

                do while onechar<>chr(27) .and. charpos<=textlen
                        ?? onechar
                        charpos=charpos+1
                        onechar=substr(ansitext,charpos,1)
                enddo

                charpos=charpos+1
                onechar=substr(ansitext,charpos,1)

                if onechar<>'['
                        charpos=charpos+1
                        loop
                endif

                do while .not. onechar $ 'ABCDHJKfhlmsu'
                        tempstrng=tempstrng+onechar
                        charpos=charpos+1
                        onechar=substr(ansitext,charpos,1)
                enddo

                if onechar='l'
                        tempstrng=''
                        charpos=charpos+1
                        loop
                endif

                if onechar='h'
                        tempstrng=''
                        charpos=charpos+1
                        loop
                endif

                if onechar='K'
                        tempstrng=substr(tempstrng,2)

                        if val(tempstrng)=0
                                @ row(),col()-1 clear to row(),79
                                tempstrng=''
                                charpos=charpos+1
                                loop
                        endif

                        if val(tempstrng)=1
                                @ row(),0 clear to row(),col()-1
                                tempstrng=''
                                charpos=charpos+1
                                loop
                        endif

                        if val(tempstrng)=2
                                @ row(),0 clear to row(),79
                                tempstrng=''
                                charpos=charpos+1
                                loop
                        endif

                endif

                if onechar='s'
                        savrow=row()
                        savcol=col()
                        tempstrng=''
                        charpos=charpos+1
                        loop
                endif

                if onechar='u'
                        @ savrow,savcol
                        tempstrng=''
                        charpos=charpos+1
                        loop
                endif

                if onechar='A'
                        tempstrng=substr(tempstrng,2)
                        temprow=row()-val(tempstrng)
                        if temprow<0
                                temprow=0
                        endif
                        tempcol=col()-1
                        @ temprow,tempcol say ''
                        tempstrng=''
                        charpos=charpos+1
                        loop
                endif

                if onechar='B'
                        tempstrng=substr(tempstrng,2)
                        temprow=row()+val(tempstrng)
                        if temprow>24
                                temprow=24
                        endif
                        tempcol=col()-1
                        @ temprow,tempcol say ''
                        tempstrng=''
                        charpos=charpos+1
                        loop
                endif

                if onechar='C'
                        tempstrng=substr(tempstrng,2)
                        temprow=row()
                        tempcol=col()-1+val(tempstrng)
                        if tempcol>79
                                tempcol=79
                        endif
                        @ temprow,tempcol say ''
                        tempstrng=''
                        charpos=charpos+1
                        loop
                endif

                if onechar='D'
                        tempstrng=substr(tempstrng,2)
                        temprow=row()
                        tempcol=col()-1-val(tempstrng)
                        if tempcol<0
                                tempcol=0
                        endif
                        @ temprow,tempcol say ''
                        tempstrng=''
                        charpos=charpos+1
                        loop
                endif

                if onechar='H' .or. onechar='f'
                        tempstrng=substr(tempstrng,2)
                        colnpos=at(';',tempstrng)
                        temprow=val(substr(tempstrng,1,colnpos-1))-1
                        if temprow<0
                                temprow=0
                        endif
                        if temprow>24
                                temprow=24
                        endif
                        tempcol=val(substr(tempstrng,colnpos+1))-1
                        if tempcol<0
                                tempcol=0
                        endif
                        if tempcol>79
                                tempcol=79
                        endif
                        @ temprow,tempcol say ''
                        tempstrng=''
                        charpos=charpos+1
                        loop
                endif

                if onechar='J'
                        tempstrng=substr(tempstrng,2)

                        if val(tempstrng)=0
                                @ row(),col()-1 clear to row(),79
                                @ row()+1,0 clear
                                tempstrng=''
                                charpos=charpos+1
                                loop
                        endif

                        if val(tempstrng)=1
                                @ row(),0 clear
                                tempstrng=''
                                charpos=charpos+1
                                loop
                        endif

                        if val(tempstrng)=2
                                @ 0,0 clear
                                tempstrng=''
                                charpos=charpos+1
                                loop
                        endif

                endif

                if onechar='m'
                        tempstrng=substr(tempstrng,2)
                        x=0
                endif

                do while onechar='m'

                        tempsubstr=''
                        x=x+1
                        tempchar=substr(tempstrng,x,1)
                        do while tempchar<>';'
                                tempsubstr=tempsubstr+tempchar
                                x=x+1
                                if x>len(tempstrng)
                                        onechar=' '
                                        exit
                                endif
                                tempchar=substr(tempstrng,x,1)
                        enddo

                        if val(tempsubstr)=0
                                sf='W'
                                sb='N'
                                ef='W'
                                eb='N'
                                uf='W'
                                ub='N'
                                setcolor('w/n,w/n,,,w/n')
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=1 .and. .not. '+' $ sf
                                sf=sf+'+'
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=2 .and. '+' $ sf
                                sf=strtran(sf,'+')
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=4
                                sf='U'
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=5 .and. .not. '*' $ sf
                                sf=sf+'*'
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=7
                                sf='I'
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=8
                                sf='X'
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=30
                                if '+' $ sf .and. .not. '*' $ sf
                                        sf='N'+'+'
                                endif
                                if '*' $ sf .and. .not. '+' $ sf
                                        sf='N'+'*'
                                endif
                                if '*' $ sf .and. '+' $ 'sf'
                                        sf='N'+'+*'
                                endif
                                if .not. '+' $ sf .and. .not. '*' $ sf
                                        sf='N'
                                endif
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=31
                                if '+' $ sf .and. .not. '*' $ sf
                                        sf='R'+'+'
                                endif
                                if '*' $ sf .and. .not. '+' $ sf
                                        sf='R'+'*'
                                endif
                                if '*' $ sf .and. '+' $ 'sf'
                                        sf='R'+'+*'
                                endif
                                if .not. '+' $ sf .and. .not. '*' $ sf
                                        sf='R'
                                endif
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=32
                                if '+' $ sf .and. .not. '*' $ sf
                                        sf='G'+'+'
                                endif
                                if '*' $ sf .and. .not. '+' $ sf
                                        sf='G'+'*'
                                endif
                                if '*' $ sf .and. '+' $ 'sf'
                                        sf='G'+'+*'
                                endif
                                if .not. '+' $ sf .and. .not. '*' $ sf
                                        sf='G'
                                endif
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=33
                                if '+' $ sf .and. .not. '*' $ sf
                                        sf='GR'+'+'
                                endif
                                if '*' $ sf .and. .not. '+' $ sf
                                        sf='GR'+'*'
                                endif
                                if '*' $ sf .and. '+' $ 'sf'
                                        sf='GR'+'+*'
                                endif
                                if .not. '+' $ sf .and. .not. '*' $ sf
                                        sf='GR'
                                endif
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=34
                                if '+' $ sf .and. .not. '*' $ sf
                                        sf='B'+'+'
                                endif
                                if '*' $ sf .and. .not. '+' $ sf
                                        sf='B'+'*'
                                endif
                                if '*' $ sf .and. '+' $ 'sf'
                                        sf='B'+'+*'
                                endif
                                if .not. '+' $ sf .and. .not. '*' $ sf
                                        sf='B'
                                endif
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=35
                                if '+' $ sf .and. .not. '*' $ sf
                                        sf='RB'+'+'
                                endif
                                if '*' $ sf .and. .not. '+' $ sf
                                        sf='RB'+'*'
                                endif
                                if '*' $ sf .and. '+' $ 'sf'
                                        sf='RB'+'+*'
                                endif
                                if .not. '+' $ sf .and. .not. '*' $ sf
                                        sf='RB'
                                endif
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=36
                                if '+' $ sf .and. .not. '*' $ sf
                                        sf='BG'+'+'
                                endif
                                if '*' $ sf .and. .not. '+' $ sf
                                        sf='BG'+'*'
                                endif
                                if '*' $ sf .and. '+' $ 'sf'
                                        sf='BG'+'+*'
                                endif
                                if .not. '+' $ sf .and. .not. '*' $ sf
                                        sf='BG'
                                endif
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=37
                                if '+' $ sf .and. .not. '*' $ sf
                                        sf='W'+'+'
                                endif
                                if '*' $ sf .and. .not. '+' $ sf
                                        sf='W'+'*'
                                endif
                                if '*' $ sf .and. '+' $ 'sf'
                                        sf='W'+'+*'
                                endif
                                if .not. '+' $ sf .and. .not. '*' $ sf
                                        sf='W'
                                endif
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=40
                                sb='N'
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=41
                                sb='R'
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=42
                                sb='G'
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=43
                                sb='GR'
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=44
                                sb='B'
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=45
                                sb='RB'
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=46
                                sb='BG'
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif

                        if val(tempsubstr)=47
                                sb='W'
                                cstrng=sf+'/'+sb+','+ef+'/'+eb+',,,'+uf+'/'+ub
                                setcolor(cstrng)
                                tempsubstr=''
                        endif
                enddo
                charpos=charpos+1
                tempstrng=''
                tempsubstr=''
        enddo

RETURN ''

